/*
 Concept.java
 Copyright (C) 2004 Jos Ramn Prez Agera
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


package thes;
import java.io.Serializable;
import java.util.*;


public class Concept implements Serializable {
	
/////////////////////////////////Variables de Clase//////////////////////////////////////////
	
	//Descriptor
	private String descriptor; //Trmino nico utilizado para representar un concepto durante la indizacin
	
	//Faceta o Campo, es un mapa hash con el cdigo numrico de la faceta como clave y el nobre de la faceta como valor
	private ArrayList field;
	
	//Relacin jerarquica
	private ArrayList narrowerTerms1;  //Listado de trminos especficos NT (Siempre son descriptores)
	private ArrayList narrowerTerms2;  //Listado de trminos especficos NT (Siempre son descriptores)
	private ArrayList narrowerTerms3;  //Listado de trminos especficos NT (Siempre son descriptores)
	private ArrayList broaderTerms1; //Listado de trminos genricos BT (Siempre son descriptores)
	private ArrayList broaderTerms2; //Listado de trminos genricos BT (Siempre son descriptores)
	private ArrayList broaderTerms3; //Listado de trminos genricos BT (Siempre son descriptores)
	
	//Relacin asociativa
	private ArrayList relatedTerms; // Listado de trminos relacionados RT (Siempre son descriptores)
	
	//Relacin de equivalencia
	private ArrayList nonDescriptors; //Listado de no descriptores o trminos equivalentes UF
	
	//Notas y observaciones
	private String scopeNote; // Notas de alcance o notas aclaratorias SN Indica la utilizacin de un descriptor cuando su significado es ambiguo
	
	//Traduccin
	private String englishTerm; // Traduccin del descriptor al espaol
	private String frenchTerm; // Traduccin del descriptor al francs
	
///////////////////////////////Constructores//////////////////////////////////////////////////	
	
	public Concept() {
			
	}
		
/**
 * @return
 */
public String getDescriptor() {
	return descriptor;
}

	/**
	 * @return
	 */
	public String getFrenchTerm() {
		return frenchTerm;
	}

	/**
	 * @return
	 */
	public ArrayList getNonDescriptors() {
		return nonDescriptors;
	}

	/**
	 * @return
	 */
	public ArrayList getRelatedTerms() {
		return relatedTerms;
	}

	/**
	 * @return
	 */
	public String getScopeNote() {
		return scopeNote;
	}

	/**
	 * @return
	 */
	public String getEnglishTerm() {
		return englishTerm;
	}

/**
 * @param string
 */
public void setDescriptor(String string) {
	descriptor = string;
}

	/**
	 * @param string
	 */
	public void setFrenchTerm(String string) {
		frenchTerm = string;
	}

	/**
	 * @param list
	 */
	public void setNonDescriptors(ArrayList list) {
		nonDescriptors = list;
	}

	/**
	 * @param list
	 */
	public void setRelatedTerms(ArrayList list) {
		relatedTerms = list;
	}

	/**
	 * @param string
	 */
	public void setScopeNote(String string) {
		scopeNote = string;
	}

	/**
	 * @param string
	 */
	public void setEnglishTerm(String string) {
		englishTerm = string;
	}


	/**
	 * @return
	 */
	public ArrayList getBroaderTerms1() {
		return broaderTerms1;
	}

	/**
	 * @return
	 */
	public ArrayList getBroaderTerms2() {
		return broaderTerms2;
	}

	/**
	 * @return
	 */
	public ArrayList getBroaderTerms3() {
		return broaderTerms3;
	}

	/**
	 * @return
	 */
	public ArrayList getField() {
		return field;
	}

	/**
	 * @return
	 */
	public ArrayList getNarrowerTerms1() {
		return narrowerTerms1;
	}

	/**
	 * @return
	 */
	public ArrayList getNarrowerTerms2() {
		return narrowerTerms2;
	}

	/**
	 * @return
	 */
	public ArrayList getNarrowerTerms3() {
		return narrowerTerms3;
	}

	/**
	 * @param list
	 */
	public void setBroaderTerms1(ArrayList list) {
		broaderTerms1 = list;
	}

	/**
	 * @param list
	 */
	public void setBroaderTerms2(ArrayList list) {
		broaderTerms2 = list;
	}

	/**
	 * @param list
	 */
	public void setBroaderTerms3(ArrayList list) {
		broaderTerms3 = list;
	}

	/**
	 * @param list
	 */
	public void setField(ArrayList list) {
		field = list;
	}

	/**
	 * @param list
	 */
	public void setNarrowerTerms1(ArrayList list) {
		narrowerTerms1 = list;
	}

	/**
	 * @param list
	 */
	public void setNarrowerTerms2(ArrayList list) {
		narrowerTerms2 = list;
	}

	/**
	 * @param list
	 */
	public void setNarrowerTerms3(ArrayList list) {
		narrowerTerms3 = list;
	}

}
