
/*
 ReaderTXT.java
 Copyright (C) 2004 Jos Ramn Prez Agera
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package thes;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class ReaderTXT {

////////////////////Variables de clase//////////////////////////////////////////////////////	
	private File file; //Es un lector sobre el archivo introducido
	private ArrayList descriptorList; //Objeto tesauro con el que trabaja la clase
	
/////////////////////////Constructores//////////////////////////////////////////	
	public ReaderTXT(String file) throws FileNotFoundException{
		this.file= new File(file);
		this.descriptorList= new ArrayList();
	}
//////////////////////////////Mtodos/////////////////////////////////////////////

	public ArrayList importThesaurus() throws IOException{
		String term=null; //Variable correspondiente a un trmino ledo del archivo de entrada
		StringTokenizer stk=null; //Sirve para comprobar que marca tiene el trmino
		String marca=null;//Corresponde a la marca que lleva asociada cada trmino
		boolean readedDES= false; //Indica si se ha leido un descriptor para guardarlo, sirve para que al iniciar la lectura no se guarde un descriptor vaco
		
		String mainTerm= null; //Variable correspondiente al descriptor
		String englishTerm= null;//Variable correspondiente al descriptor en ingls
		String frenchTerm= null;//Variable correspondiente al descriptor en francs
		String note= "";//Variable correspondiente a una nota aclaratoria
		
		ArrayList genericTerm1= null;//Variable correspondiente a un lista de trminos genricos de primer nivel
		ArrayList genericTerm2= null;//Variable correspondiente a un lista de trminos genricos de segundo nivel
		ArrayList genericTerm3= null;//Variable correspondiente a un lista de trminos genricos de tercer nivel
		ArrayList especificTerm1= null;//Variable correspondiente a una lista de trminos especficos
		ArrayList especificTerm2= null;//Variable correspondiente a una lista de trminos especficos
		ArrayList especificTerm3= null;//Variable correspondiente a una lista de trminos especficos
		ArrayList relatedTerm= null;//Variable correspondiente a una lista de trminos relacionados
		ArrayList equivalentTerm= null;//Variable correspondiente a una lista de trminos equivalentes
		ArrayList faceta= null;//Variable correspondiente a un lista de facetas
		
		BufferedReader br= new BufferedReader( //Inicializo un lector sobre el archivo que corresponde a este lector
			new InputStreamReader(
				new FileInputStream(this.file)));
		
		term=br.readLine();//Leo la primera lnea del archivo
		
		while(term.equals("")){ //Elimino saltos de lnea que pueden desvirtuar la lectura
			term=br.readLine();
		}
		
		while(term!=null){
			stk= new StringTokenizer(term, " ");//Este StringTokenizer contiene el String entero que ha leido br.readLine()
			if(stk.hasMoreTokens()){
				marca=stk.nextToken(); //No iteramos sobre el StringTokenizer, tan solo guardamos en la variable "marca" el primer token que corresponde a la marca del trmino 
			}
			
			if(marca.equals("DES")){ //Si la marca es DES lo identificamos como trmino principal
				if(!readedDES){
						mainTerm=quitarMarca(term,"DES").toLowerCase().trim();
						readedDES=true;					
				} else {
					//Creo el objeto Descriptor
					Concept concept= new Concept();
					concept.setDescriptor(mainTerm);
					System.out.println(mainTerm);
					concept.setEnglishTerm(englishTerm);
					System.out.println(englishTerm);
					concept.setFrenchTerm(frenchTerm);
					System.out.println(frenchTerm);
					if(!note.equals("")){
						concept.setScopeNote(note);
						System.out.println(note);
					}
					if(genericTerm1!=null){
						concept.setBroaderTerms1(genericTerm1);
					}
					if(genericTerm2!=null){
						concept.setBroaderTerms2(genericTerm2);
					}
					if(genericTerm3!=null){
						concept.setBroaderTerms3(genericTerm3);
					} 
					if(especificTerm1!=null){
						concept.setNarrowerTerms1(especificTerm1);
					}
					if(especificTerm2!=null){
						concept.setNarrowerTerms2(especificTerm2);
					}
					if(especificTerm3!=null){
						concept.setNarrowerTerms2(especificTerm3);
					}
					if(relatedTerm!=null){
						concept.setRelatedTerms(relatedTerm);
					}
					if(equivalentTerm!=null){
						concept.setNonDescriptors(equivalentTerm);
					}
					if(faceta!=null){
						concept.setField(faceta);
					}
					this.descriptorList.add(concept);
					//Lo pongo todo a null para volver a empezar con el descriptor siguiente
					englishTerm= null;
					frenchTerm= null;
					mainTerm= null;
					note= "";
					genericTerm1= null;
					genericTerm2= null;
					genericTerm3= null;
					especificTerm1= null;
					especificTerm2= null;
					especificTerm3= null;
					relatedTerm= null;
					equivalentTerm= null;
					faceta= null;
					mainTerm=quitarMarca(term,"DES").toLowerCase().trim();
					readedDES=true;	
				}
			}
			
			if(marca.equals("EN")){ //Si la marca es EN lo identificamos como trmino en ingls
				englishTerm=quitarMarca(term,"EN").toLowerCase().trim();
				//System.out.println(englishTerm);
			}
			
			if(marca.equals("FR")){ //Si la marca es FR lo identificamos como trmino en francs
				frenchTerm=quitarMarca(term, "FR").toLowerCase().trim();
				//System.out.println(frenchTerm);
			}
			
			if(marca.equals("NA")){ //Si la marca es NA lo identificamos como una nota aclaratoria. Las notas de un mismo descriptor se concatenan para guardarlas unificadas
				note=note.concat(quitarMarca(term, "NA")).toLowerCase();
				//System.out.println(note);
			}
						
			if(marca.equals("<")) { //Si la marca es < lo identificamos como trmino general de primer nivel
				if(genericTerm1 == null) {
					genericTerm1= new ArrayList();
				}
				genericTerm1.add(quitarMarca(term,"<").toLowerCase().trim());
			}
			
			if(marca.equals(".<")) {//Si la marca es .< lo identificamos como trmino general de segundo nivel
				if(genericTerm2 == null) {
					genericTerm2= new ArrayList();
				}
				genericTerm2.add(quitarMarca(term,".<").toLowerCase().trim());
			}
			
			if(marca.equals("..<")) {//Si la marca es ..< lo identificamos como trmino general de tercer nivel
				if(genericTerm3 == null) {
					genericTerm3= new ArrayList();
				}
				genericTerm3.add(quitarMarca(term,"..<").toLowerCase().trim());
			}
			
			if(marca.equals(">")) { //Si la marca es > lo identificamos como un trmino especfico de primer nivel
				if(especificTerm1 == null) {
					especificTerm1= new ArrayList();
				}
				especificTerm1.add(quitarMarca(term,">").toLowerCase().trim());
			}
			
			if(marca.equals(".>")) { //Si la marca es .> lo identificamos como un trmino especfico de segundo nivel
				if(especificTerm2 == null) {
					especificTerm2= new ArrayList();
				}
				especificTerm2.add(quitarMarca(term,".>").toLowerCase().trim());
			}
			
			if(marca.equals("..>")) { //Si la marca es ..> lo identificamos como un trmino especfico de tercer nivel
				if(especificTerm3 == null) {
					especificTerm3= new ArrayList();
				}
				especificTerm3.add(quitarMarca(term,"..>").toLowerCase().trim());
			}
			
			if(marca.equals("LT")) {//Si la marca es LT lo identificamos como una faceta
				if(faceta == null) {
					faceta= new ArrayList();
				}
				faceta.add(quitarMarca(term,"LT").toLowerCase().trim());
			}
			
			if(marca.equals("=") || marca.equals("*")) {// Si la marca es = lo identificamos como un trmino equivalente o no-descriptor
				if(equivalentTerm == null) {
					equivalentTerm= new ArrayList();
				}
				if(marca.equals("=")){
					equivalentTerm.add(quitarMarca(term,"=").toLowerCase().trim());
				}
				if(marca.equals("*")){
					equivalentTerm.add(quitarMarca(term,"*").toLowerCase().trim());
				}
			}
			
			if(marca.equals("-")) {//Si la marca es - lo identificamos como un trmino relacionado
				if(relatedTerm == null) {
					relatedTerm= new ArrayList();
				}
				relatedTerm.add(quitarMarca(term,"-").toLowerCase().trim());
			}
			
			if(marca.equals("=>") || marca.equals(":")){
				englishTerm= null;
				frenchTerm= null;
				mainTerm= null;
				note= "";
				genericTerm1= null;
				genericTerm2= null;
				genericTerm3= null;
				especificTerm1= null;
				especificTerm2= null;
				especificTerm3= null;
				relatedTerm= null;
				equivalentTerm= null;
				faceta= null;			
				readedDES=false;	
			}
			term=br.readLine();
			if(term == null) {
//				Creo el objeto Descriptor para el ltimo descriptor porque si no lo hago as no entra a causa de que el siguiente valor de term es null
				Concept concept= new Concept();
				concept.setDescriptor(mainTerm);
				System.out.println(mainTerm);
				concept.setEnglishTerm(englishTerm);
				System.out.println(englishTerm);
				concept.setFrenchTerm(frenchTerm);
				System.out.println(frenchTerm);
				if(!note.equals("")){
					concept.setScopeNote(note);
					System.out.println(note);
				}
				if(genericTerm1!=null){
					concept.setBroaderTerms1(genericTerm1);
				}
				if(genericTerm2!=null){
					concept.setBroaderTerms2(genericTerm2);
				}
				if(genericTerm3!=null){
					concept.setBroaderTerms3(genericTerm3);
				} 
				if(especificTerm1!=null){
					concept.setNarrowerTerms1(especificTerm1);
				}
				if(especificTerm2!=null){
					concept.setNarrowerTerms2(especificTerm2);
				}
				if(especificTerm3!=null){
					concept.setNarrowerTerms2(especificTerm3);
				}
				if(relatedTerm!=null){
					concept.setRelatedTerms(relatedTerm);
				}
				if(equivalentTerm!=null){
					concept.setNonDescriptors(equivalentTerm);
				}
				if(faceta!=null){
					concept.setField(faceta);
				}
				this.descriptorList.add(concept);
			}
													
		}
		System.out.println("Termine");
		return this.descriptorList;	
	}
	
//	Este mtodo devuelve el nmero de leidos del archivo
	public int getSizeList(){ 
		return this.descriptorList.size();
	}
	
	
	public static String quitarMarca(String texto, String marca) {
		StringTokenizer st= new StringTokenizer(texto);
		String ss="";
		String sss="";
		while(st.hasMoreTokens()) {
			ss= st.nextToken();
			if(ss.equals(marca)) {
				ss=st.nextToken();
			}
			sss = sss.concat( ss + " ");			
		}
		return sss;
	}
}	
