
/*
 SKOS.java
 Copyright (C) 2004 Jos Ramn Prez Agera
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package thes;
import com.hp.hpl.jena.rdf.model.*;

public class SKOS {


    public static final String uri ="http://www.w3.org/2004/02/skos/core#";

    private static Model m = ModelFactory.createDefaultModel();

    public static Property semanticRelation = m.createProperty(uri+"semanticRelation");
    public static Property broader = m.createProperty(uri+"broader");
    public static Property narrower = m.createProperty(uri+"narrower");
    public static Property related = m.createProperty(uri+"related");
    public static Property broaderGeneric = m.createProperty(uri+"broaderGeneric");
    public static Property broaderInstantive = m.createProperty(uri+"broaderInstantive");
    public static Property broaderPartitive = m.createProperty(uri+"broaderPartitive");
    public static Property narrowerGeneric = m.createProperty(uri+"narrowerGeneric");
    public static Property narrowerInstantive = m.createProperty(uri+"narrowerInstantive");
    public static Property narrowerPartitive = m.createProperty(uri+"narrowerPartitive");
    public static Property relatedPartOf = m.createProperty(uri+"relatedPartOf");
    public static Property relatedHasPart = m.createProperty(uri+"relatedHasPart");

    public static Property externalID = m.createProperty(uri+"externalID");
    public static Property prefLabel = m.createProperty(uri+"prefLabel");
    public static Property altLabel = m.createProperty(uri+"altLabel");
    public static Property prefSymbol = m.createProperty(uri+"prefSymbol");
    public static Property altSymbol = m.createProperty(uri+"altSymbol");
    public static Property scopeNote = m.createProperty(uri+"scopeNote");
    public static Property definition = m.createProperty(uri+"definition");
    public static Property example = m.createProperty(uri+"example");

    public static Property inScheme = m.createProperty(uri+"inScheme");

    public static Resource Concept = m.createResource(uri+"Concept");
    public static Resource TopConcept = m.createResource(uri+"TopConcept");
    public static Resource ConceptScheme = m.createResource(uri+"ConceptScheme");

    public static Resource Array = m.createResource(uri+"Array");

    public static Property array = m.createProperty(uri+"array");
    public static Property members = m.createProperty(uri+"members");
    public static Property ordered = m.createProperty(uri+"ordered");

}


